Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/SelectPackagesWizardPage.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/SelectPackagesWizardPage.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/SelectPackagesWizardPage.java	(revision 43126)
@@ -0,0 +1,285 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2013 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
+ *
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.installer.swing.impl.execution.wizard;
+
+import java.util.Iterator;
+import java.util.List;
+
+import javax.swing.JOptionPane;
+import javax.swing.JPanel;
+
+import org.gvsig.gui.beans.wizard.panel.NotContinueWizardException;
+import org.gvsig.gui.beans.wizard.panel.OptionPanel;
+import org.gvsig.installer.lib.api.Dependencies;
+import org.gvsig.installer.lib.api.DependenciesCalculator;
+import org.gvsig.installer.lib.api.InstallerLocator;
+import org.gvsig.installer.lib.api.InstallerManager;
+import org.gvsig.installer.lib.api.PackageInfo;
+import org.gvsig.installer.swing.api.SwingInstallerLocator;
+import org.gvsig.installer.swing.api.SwingInstallerManager;
+import org.gvsig.installer.swing.api.execution.JShowPackageStatusAndAskContinuePanel;
+import org.gvsig.installer.swing.api.execution.JShowPackagesAndAskContinuePanel;
+import org.gvsig.installer.swing.api.execution.JShowRequiredPackagesAndAskContinuePanel;
+import org.gvsig.installer.swing.api.execution.JShowUnresolvedDependenciesAndAskContinuePanel;
+import org.gvsig.installer.swing.api.execution.PackageFilter;
+import org.gvsig.installer.swing.impl.execution.InstallWizardPanel_ext;
+import org.gvsig.installer.swing.impl.execution.panel.SelectPackagesPanel;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.windowmanager.WindowManager;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class SelectPackagesWizardPage implements OptionPanel {
+
+    private static final long serialVersionUID = -4678172923039393643L;
+
+    private static final Logger LOG = LoggerFactory.getLogger(SelectPackagesWizardPage.class);
+
+    private final InstallWizardPanel_ext wizardPanel;
+
+    private SelectPackagesPanel selectPackagesPanel = null;
+
+    public SelectPackagesWizardPage(
+            InstallWizardPanel_ext wizardPanel) {
+        super();
+        this.wizardPanel = wizardPanel;
+        this.selectPackagesPanel = new SelectPackagesPanel(this);
+    }
+    
+    @Override
+    public JPanel getJPanel() {
+        return selectPackagesPanel;
+    }
+
+    @Override
+    public String getPanelTitle() {
+        return wizardPanel.getTranslation("_select_plugins");
+    }
+
+    @Override
+    public void lastPanel() {
+        selectPackagesPanel.clearPanel();
+    }
+
+    @Override
+    public void nextPanel() throws NotContinueWizardException {
+        SwingInstallerManager swingManager = SwingInstallerLocator.getSwingInstallerManager();
+        /*
+         * First warn about packages in development or unofficial
+         */
+        checkDevelAndUnoficialPackages(swingManager);
+        /*
+         * Then check dependencies
+         */
+        checkDependencies(swingManager);
+        wizardPanel.setNextButtonEnabled(false);
+    }
+
+    private void checkDependencies(SwingInstallerManager swingManager) throws NotContinueWizardException {
+        List<PackageInfo> requiredPackages = null;
+        List<PackageInfo> troubledPackages = null;
+        Dependencies unresolvedDependencies = null;
+        try {
+            InstallerManager manager = InstallerLocator.getInstallerManager();
+            // Creamos el calculador de dependencias
+            DependenciesCalculator calculator = manager.createDependenciesCalculator(
+                wizardPanel.getInstallerExecutionService()
+            );
+
+            // Le indicamos los paquetes que queremos instalar
+            calculator.addPackageToInstall(
+                    this.wizardPanel.getPackagesToInstall()
+            );
+
+            // Le añadimos los paquetes que ya hay instalados.
+            PackageInfo[] pkgs = manager.getInstalledPackages();
+            calculator.addInstalledPackage(pkgs);
+
+            // Calculamos las dependencias
+            calculator.calculate();
+
+            requiredPackages = calculator.getRequiredPackages();
+            unresolvedDependencies = calculator.getUnresolvedDependencies();
+            troubledPackages = calculator.getConflictPackages();
+        } catch (Throwable e) {
+            LOG.warn(
+                    wizardPanel.getTranslation("_an_error_has_occurred_when_calculating_the_dependecies_of_the_packages_to_install"),
+                    e
+            );
+            int resp = JOptionPane.showConfirmDialog(
+                null,
+                wizardPanel.getTranslation("_an_error_has_occurred_when_calculating_the_dependecies_of_the_selected_packages") +
+                "\n" +
+                wizardPanel.getTranslation("_it_is_not_possible_to_verify_if_any_additional_package_is_needed_to_install_the_selected_packages") +
+                "\n" +
+                wizardPanel.getTranslation("_if_you_want_you_can_select_again_manually_the_packets_that_might_be_necessary") +
+                wizardPanel.getTranslation("_do_you_want_to_continue_and_install_the_packages_you_already_have_selected"), 
+                wizardPanel.getTranslation("_a_problem_has_occurred_when_calculating_the_dependencies"),
+                JOptionPane.YES_NO_OPTION,
+                JOptionPane.WARNING_MESSAGE
+            );
+            if (resp == JOptionPane.NO_OPTION) {
+                throw new NotContinueWizardException("", null, false);
+            }
+        }
+
+        if (troubledPackages != null && troubledPackages.size() > 0) {
+            JShowPackagesAndAskContinuePanel dlg = swingManager
+                    .createJShowTroubledPackagesAndAskContinuePanel(
+                            troubledPackages,
+                            wizardPanel.getTranslation("_Some_of_the_selected_addons_should_not_be_installed_simultaneously")
+                            + ". "
+                            + wizardPanel.getTranslation("_Installing_these_addons_may_cause_errors")
+                            + "\n"
+                            + wizardPanel.getTranslation("_do_you_want_to_continue")
+                    );
+            if (dlg.needShow()) {
+                WindowManager wm = ToolsSwingLocator.getWindowManager();
+                wm.showWindow(
+                    dlg, 
+                    wizardPanel.getTranslation("_do_you_want_to_continue"),
+                    WindowManager.MODE.DIALOG
+                );
+                if (dlg.cancelled()) {
+                    throw new NotContinueWizardException("", null, false);
+                }
+            }
+        }
+
+        if (requiredPackages != null && requiredPackages.size() > 0) {
+            JShowRequiredPackagesAndAskContinuePanel dlg = swingManager
+                    .createJShowRequiredPackagesAndAskContinuePanel(
+                            requiredPackages,
+                            wizardPanel.getTranslation("_the_selected_packages_require_to_install_or_update_the_following_packages")
+                            + ":\n"
+                            + wizardPanel.getTranslation("_do_you_want_to_continue"));
+            if (dlg.needShow()) {
+                WindowManager wm = ToolsSwingLocator.getWindowManager();
+                wm.showWindow(
+                    dlg, 
+                    wizardPanel.getTranslation("_do_you_want_to_continue"),
+                    WindowManager.MODE.DIALOG
+                );
+                if (dlg.cancelled()) {
+                    throw new NotContinueWizardException("", null, false);
+                }
+            }
+        }
+
+        if (unresolvedDependencies != null && unresolvedDependencies.size() > 0) {
+            JShowUnresolvedDependenciesAndAskContinuePanel dlg = swingManager
+                .createJShowUnresolvedDependenciesAndAskContinuePanel(
+                    unresolvedDependencies,
+                    wizardPanel.getTranslation("_the_following_dependencies_have_not_been_possible_to_resolve")
+                    + ". "
+                    + wizardPanel.getTranslation("_This_may_cause_issues_in_gvSIG")
+                    + "\n"
+                    + wizardPanel.getTranslation("_do_you_want_to_continue_anyway")
+                );
+            if (dlg.needShow()) {
+                WindowManager wm = ToolsSwingLocator.getWindowManager();
+                wm.showWindow(
+                    dlg, 
+                    wizardPanel.getTranslation("_do_you_want_to_continue"),
+                    WindowManager.MODE.DIALOG
+                );
+                if (dlg.cancelled()) {
+                    throw new NotContinueWizardException("", null, false);
+                }
+            }
+        }
+
+        Iterator<PackageInfo> it = requiredPackages.iterator();
+        while (it.hasNext()) {
+            PackageInfo pkg = it.next();
+            selectPackagesPanel.getModel().selectPackage(pkg);
+            LOG.info("Automatic selection of required package " + pkg.getCode());
+        }
+    }
+
+    private void checkDevelAndUnoficialPackages(SwingInstallerManager swingManager)
+            throws NotContinueWizardException {
+        List<PackageInfo> packagesToInstall = this.wizardPanel.getPackagesToInstall();
+
+        JShowPackageStatusAndAskContinuePanel dlg = swingManager
+                .createJShowPackageStatusAndAskContinuePanel(
+                        packagesToInstall,
+                        wizardPanel.getTranslation("_you_have_selected_in_development_or_not_official_versions")
+                        + ". "
+                        + wizardPanel.getTranslation("_Installing_devel_addons_may_cause_errors")
+                        + "\n"
+                        + wizardPanel.getTranslation("_do_you_want_to_continue_anyway"));
+        if (dlg.needShow()) {
+            WindowManager wm = ToolsSwingLocator.getWindowManager();
+            wm.showWindow(
+                    dlg, 
+                    wizardPanel.getTranslation("_do_you_want_to_continue"),
+                    WindowManager.MODE.DIALOG
+            );
+            if (dlg.cancelled()) {
+                throw new NotContinueWizardException("", null, false);
+            }
+        }
+    }
+
+    @Override
+    public void updatePanel() {
+        selectPackagesPanel.updatePanel();
+        selectPackagesPanel.setInitialFilter();
+
+        // if default packages must be selected or not
+        if (wizardPanel.getSelectDefaultPackages()) {
+            selectPackagesPanel.selectPackages();
+        }
+        wizardPanel.setFinishButtonEnabled(true);
+        wizardPanel.setBackButtonEnabled(true);
+        wizardPanel.setNextButtonEnabled(false);
+        wizardPanel.setCancelButtonEnabled(true);
+
+        this.selectPackagesPanel.setBaseFilter(this.wizardPanel.getPackageFilter());
+
+        if (wizardPanel.getSkipSelectPackagesWizardPage() && !this.getPackagesToInstall().isEmpty()) {
+            wizardPanel.skip();
+            return;
+        }
+
+        checkIfPluginSelected();
+    }
+
+    public void checkIfPluginSelected() {
+        wizardPanel.setNextButtonEnabled(selectPackagesPanel.isPackageSelected());
+    }
+
+    public List<PackageInfo> getPackagesToInstall() {
+        return selectPackagesPanel.getPackagesToInstall();
+    }
+
+    public Boolean isDefaultPackagesSelectionSet() {
+        return wizardPanel.getSelectDefaultPackages();
+    }
+
+    public InstallWizardPanel_ext getWizardPanel() {
+        return this.wizardPanel;
+    }
+
+}

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/InstallersWizardPage.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/InstallersWizardPage.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/InstallersWizardPage.java	(revision 43126)
@@ -0,0 +1,159 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2013 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or modify it under
+ * the terms of the GNU General Public License as published by the Free Software
+ * Foundation; either version 3 of the License, or (at your option) any later
+ * version.
+ *
+ * This program is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
+ * details.
+ *
+ * You should have received a copy of the GNU General Public License along with
+ * this program; if not, write to the Free Software Foundation, Inc., 51
+ * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us at info AT
+ * gvsig.com, or visit our website www.gvsig.com.
+ */
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 {Prodevelop}   {Task}
+ */
+package org.gvsig.installer.swing.impl.execution.wizard;
+
+import javax.swing.JOptionPane;
+
+import javax.swing.JPanel;
+import javax.swing.SwingUtilities;
+import org.gvsig.gui.beans.wizard.WizardPanelWithLogo;
+
+import org.gvsig.gui.beans.wizard.panel.OptionPanel;
+import org.gvsig.installer.lib.api.execution.InstallPackageService;
+import org.gvsig.installer.swing.api.SwingInstallerLocator;
+import org.gvsig.installer.swing.api.SwingInstallerManager;
+import org.gvsig.installer.swing.impl.DefaultSwingInstallerManager;
+import org.gvsig.installer.swing.impl.execution.InstallWizardPanel_ext;
+import org.gvsig.installer.swing.impl.panel.DefaultProgressPanel;
+import org.gvsig.tools.task.AbstractMonitorableTask;
+import org.gvsig.tools.task.SimpleTaskStatus;
+
+public class InstallersWizardPage extends DefaultProgressPanel implements OptionPanel {
+
+    private static final long serialVersionUID = 8531884535246881448L;
+    private final InstallWizardPanel_ext wizardPanel;
+
+    public InstallersWizardPage(InstallWizardPanel_ext installerExecutionWizard) {
+        super();
+        this.wizardPanel = installerExecutionWizard;
+    }
+
+    @Override
+    public JPanel getJPanel() {
+        return this;
+    }
+
+    @Override
+    public String getPanelTitle() {
+        return wizardPanel.getTranslation("_Install_required_addons");
+    }
+
+    @Override
+    public void lastPanel() {
+        wizardPanel.setFinishButtonEnabled(false);
+        wizardPanel.setCancelButtonEnabled(true);
+    }
+
+    @Override
+    public void nextPanel() {
+    }
+
+    @Override
+    public void updatePanel() {
+        if( wizardPanel.getDirection() == WizardPanelWithLogo.ACTION_PREVIOUS ) {
+            wizardPanel.skip();
+            return;
+        }
+        InstallPackageService bundle = wizardPanel.getInstallerExecutionService();
+        if (! bundle.needInstallPackageProviders()) {
+            wizardPanel.skip();
+            return;
+        }
+
+        wizardPanel.setFinishButtonEnabled(false);
+        wizardPanel.setBackButtonEnabled(false);
+        wizardPanel.setNextButtonEnabled(false);
+        wizardPanel.setCancelButtonEnabled(true);
+
+        UpdatePanel task = new UpdatePanel(this);
+        this.wizardPanel.addCancellableTask(task);
+        bind(task.getTaskStatus());
+        task.setDaemon(true);
+        task.start();
+    }
+
+    private class UpdatePanel extends AbstractMonitorableTask {
+
+        private final InstallersWizardPage panel;
+
+        public UpdatePanel(InstallersWizardPage panel) {
+            super(panel.wizardPanel.getTranslation("_Installing prerequisites..."));
+            this.panel = panel;
+        }
+
+        private void showWarning(final String msg) {
+            if (!SwingUtilities.isEventDispatchThread()) {
+                try {
+                    SwingUtilities.invokeAndWait(new Runnable() {
+                        @Override
+                        public void run() {
+                        }
+                    });
+                } catch (Exception ex) {
+                    logger.warn("Cant show message to the user. " + msg);
+                }
+                return;
+            }
+            JOptionPane.showMessageDialog(panel, msg, "Warning", JOptionPane.WARNING_MESSAGE);
+        }
+
+        @Override
+        public synchronized void run() {
+
+            try {
+
+                logger.info("Package installation initiated");
+                SimpleTaskStatus taskStatus = (SimpleTaskStatus) this.getTaskStatus();
+
+                InstallPackageService bundle = wizardPanel.getInstallerExecutionService();
+                if (bundle.needInstallPackageProviders()) {
+                    bundle.installPackageProviders(taskStatus);
+                }
+
+                taskStatus.message(panel.wizardPanel.getTranslation("_Finished"));
+
+                taskStatus.terminate();
+                SwingUtilities.invokeAndWait(new Runnable() {
+
+                    @Override
+                    public void run() {
+                        wizardPanel.setFinishButtonEnabled(false);
+                        wizardPanel.setBackButtonEnabled(true);
+                        wizardPanel.setNextButtonEnabled(true);
+                        wizardPanel.setCancelButtonEnabled(true);
+                        wizardPanel.doAction(WizardPanelWithLogo.ACTION_NEXT);
+                    }
+                });
+                logger.info("Package installation finished");
+            } catch (Throwable th) {
+                logger.warn("Problems install packages.", th);
+                showWarning(panel.wizardPanel.getTranslation("_Cant_install_package"));
+            }
+        }
+
+    }
+}

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/ProgressWizardPage.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/ProgressWizardPage.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.installer/org.gvsig.installer.swing/org.gvsig.installer.swing.impl/src/main/java/org/gvsig/installer/swing/impl/execution/wizard/ProgressWizardPage.java	(revision 43126)
@@ -0,0 +1,166 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2013 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA 02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+/*
+ * AUTHORS (In addition to CIT):
+ * 2010 {Prodevelop}   {Task}
+ */
+package org.gvsig.installer.swing.impl.execution.wizard;
+
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.List;
+import javax.swing.JOptionPane;
+
+import javax.swing.JPanel;
+import javax.swing.SwingUtilities;
+
+import org.gvsig.gui.beans.wizard.panel.OptionPanel;
+import org.gvsig.installer.lib.api.PackageInfo;
+import org.gvsig.installer.lib.api.execution.InstallPackageService;
+import org.gvsig.installer.swing.impl.execution.InstallWizardPanel_ext;
+import org.gvsig.installer.swing.impl.panel.DefaultProgressPanel;
+import org.gvsig.tools.task.AbstractMonitorableTask;
+import org.gvsig.tools.task.SimpleTaskStatus;
+
+
+public class ProgressWizardPage extends DefaultProgressPanel implements OptionPanel {
+
+    private static final long serialVersionUID = 8531884535246881448L;
+    private final InstallWizardPanel_ext wizardPanel;
+
+    public ProgressWizardPage(InstallWizardPanel_ext wizardPanel) {
+        super();
+        this.wizardPanel = wizardPanel;
+    }
+
+    @Override
+    public JPanel getJPanel() {
+        return this;
+    }
+
+    @Override
+    public String getPanelTitle() {
+        return wizardPanel.getTranslation("_progress");
+    }
+
+    @Override
+    public void lastPanel() {
+        wizardPanel.setFinishButtonEnabled(false);
+        wizardPanel.setCancelButtonEnabled(true);
+    }
+
+    @Override
+    public void nextPanel() {
+        // Nothing to do, no next panel
+    }
+
+    @Override
+    public void updatePanel() {
+        wizardPanel.setFinishButtonEnabled(false);
+        wizardPanel.setCancelButtonEnabled(false);
+
+        final ProgressWizardPage wizard = this;
+
+        UpdatePanel task = new UpdatePanel(wizard);
+        wizard.wizardPanel.addCancellableTask(task);
+        bind(task.getTaskStatus());
+        task.setDaemon(true);
+        task.start();
+    }
+
+    private static class UpdatePanel extends AbstractMonitorableTask {
+
+        private final ProgressWizardPage panel;
+
+        public UpdatePanel(ProgressWizardPage panel) {
+            super(panel.wizardPanel.getTranslation("_Install_package"));
+            this.panel = panel;
+        }
+
+        private void showWarning(final String msg) {
+            if( !SwingUtilities.isEventDispatchThread() )  {
+                try {
+                    SwingUtilities.invokeAndWait(new Runnable() {
+                        public void run() {
+                        }
+                    });
+                } catch (Exception ex) {
+                    logger.warn("Cant show message to the user. "+msg);
+                }
+                return;
+            }
+            JOptionPane.showMessageDialog(panel, msg, "Warning", JOptionPane.WARNING_MESSAGE);
+        }
+        
+        @Override
+        public synchronized void run() {
+
+            int errcount = 0;
+            try {
+                logger.info("Package installation iniitiated");
+                SimpleTaskStatus taskStatus = (SimpleTaskStatus) this.getTaskStatus();
+                // bundle of packages
+                InstallPackageService installerExecutionService = this.panel.wizardPanel
+                        .getInstallerExecutionService();
+                // packages to install
+                List<PackageInfo> installersToInstall = this.panel.wizardPanel
+                        .getPackagesToInstall();
+                Collections.sort(installersToInstall, new Comparator<PackageInfo>() {
+                    public int compare(PackageInfo o1, PackageInfo o2) {
+                        return o1.getCode().compareTo(o2.getCode());
+                    }
+                });
+                taskStatus.setRangeOfValues(0, installersToInstall.size());
+                for ( int i = 0; i < installersToInstall.size(); i++ ) {
+                    PackageInfo installerInfo = installersToInstall.get(i);
+                    taskStatus.message(installerInfo.getName());
+                    try {
+                        installerExecutionService.installPackage(
+                                panel.wizardPanel.getApplicationFolder(),
+                                installerInfo
+                        );
+                    } catch (Throwable th) {
+                        logger.warn("Can't install package '" + installerInfo.getCode() + "'.", th);
+                        errcount++;
+                    }
+                    taskStatus.setCurValue(i + 1);
+                }
+                this.panel.wizardPanel.setFinishButtonEnabled(true);
+                if( errcount>0 ) {
+                    showWarning("Failed to install "+errcount+" packages.");
+                }
+                taskStatus.message(panel.wizardPanel.getTranslation("_Finished"));
+
+                taskStatus.terminate();
+                taskStatus.remove();
+                logger.info("Package installation finished");
+            } catch (Throwable th) {
+                logger.warn("Problems install packages.",th);
+                showWarning(panel.wizardPanel.getTranslation("_Cant_install_packege"));
+            }
+
+        }
+
+    }
+}

